﻿
BrokerItemlist = LibStub("AceAddon-3.0"):NewAddon("Broker_Itemlist", "AceBucket-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local C = LibStub("AceConfigDialog-3.0")

local mod = BrokerItemlist
local db
local PLAYER_LEVEL = UnitLevel("player")

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "enUS", true)
	
if L then
	L["Items"] = true
	L["Items you wish to monitor in tooltip."] = true
	L["Settings"] = true
	L["Show in text"] = true
	L["Items you wish to show in text field."] = true
	L["Dev Mode"] = true
	L["Icon size"] = true
	L["Add item"] = true
	L["Add new item to track.  Drag the item to this input box."] = true
	L["Delete item"] = true
	L["List of current items.  Click to delete item."] = true
	L["Icon x offset"] = true
	L["Horizontal distance between icon and text."] = true
	L["Icon y offset"] = true
	L["Vertical attachment of text to icon."] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "zhTW")
	
if L then
L["Add item"] = "新增物品"
L["Add new item to track.  Drag the item to this input box."] = "新增物品追蹤。拖動此物品本匯入框。"
L["Delete item"] = "刪除物品"
L["Dev Mode"] = "開機模式"
L["Icon size"] = "圖示大小"
L["Items"] = "物品"
L["Items you wish to monitor."] = "Items you wish to monitor." -- Needs review
L["Items you wish to show in text field."] = "Items you wish to show in text field." -- Needs review
L["List of current items.  Click to delete item."] = "目前清單物品。點選刪除物品"
L["Settings"] = "設定"
L["Show in text"] = "顯示文字"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "ruRU")
	
if L then
L["Add item"] = "Добавить предмет"
L["Add new item to track.  Drag the item to this input box."] = "Добавить новый предмет для отслеживания. Перетащите предмет в поле ввода"
L["Delete item"] = "Удалить предмет"
L["Icon size"] = "Размер иконок"
L["Items"] = "Предметы"
L["List of current items.  Click to delete item."] = "Список предметов на данный момент. Кликните для удаления предмета"
L["Settings"] = "Настройки"
L["Show in text"] = "Отображать в качестве текста"

end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_Itemlist", "koKR")
	
if L then
L["Add item"] = "아이템 추가"
L["Add new item to track.  Drag the item to this input box."] = "표시할 새로운 아이템을 추가합니다. 해당 아이템을 입력칸에 드래그하세요."
L["Delete item"] = "아이템 삭제"
L["Dev Mode"] = "개발 보드"
L["Icon size"] = "아이콘 크기"
L["Items"] = "아이템"
L["Items you wish to monitor."] = "모니터 할 아이템"
L["Items you wish to show in text field."] = "텍스트 필드에 표시할 아이템"
L["List of current items.  Click to delete item."] = "현재 아이템 목록. 삭제할 아이템을 클릭하세요."
L["Settings"] = "설정"
L["Show in text"] = "텍스트 표시"

end

local L = LibStub("AceLocale-3.0"):GetLocale("Broker_Itemlist")

local playerClass
local ItemInfo = {}
local sorted = {}
local itemsList
local CURRENCYUPDATED

local ClassIcons = { ["DRUID"] = "Interface\\Icons\\INV_Misc_Branch_01", ["MAGE"] = "Interface\\Icons\\INV_Misc_Dust_01", ["PALADIN"] = "Interface\\Icons\\INV_Stone_WeightStone_05",
			["PRIEST"] = "Interface\\Icons\\INV_Misc_Candle_03", ["ROGUE"] = "Interface\\Icons\\Trade_BrewPoison", ["SHAMAN"] = "Interface\\Icons\\INV_Jewelry_Talisman_06",
			["WARLOCK"] = "Interface\\Icons\\INV_Misc_Gem_Amethyst_02", ["DEATHKNIGHT"] = "Interface\\Icons\\INV_Misc_Dust_02", ["HUNTER"] = "Interface\\Icons\\INV_Ammo_Arrow_02"
}

local ReagentDefaults = { 	["DRUID"] = {17021, 17026, 22148, 17034, 17035, 17036, 17037, 17038, 22147, 44614, 44605},
				["MAGE"] = {17020, 17031, 17032, 17056}, ["PALADIN"] = {17033, 21177}, ["PRIEST"] = {17028, 17029, 44615, 17056},
				["ROGUE"] = {7676, 6947, 2892, 3775, 5237, 10918, 21835}, ["SHAMAN"] = {17030, 17057, 17058},
				["WARLOCK"] = {6265, 5509, 16893, 41191, 41169, 5565, 16583}, ["DEATHKNIGHT"] = {37201},
				["HUNTER"] = {}, ["WARRIOR"] = {}
}

local QualityColor = {	[1] = "|c009d9d9d", 
			[2] = "|c00ffffff", 
			[3] = "|c001eff00", 
			[4] = "|c000070dd", 
			[5] = "|c00a335ee",
			[6] = "|c00ff8000", 
			[7] = "|c00e6cc80"
}

local defaults = {
	char = {
		devmode = nil,
		firstrun = true,
		iconsize = 28,
		iconx = 0,
		icony = 0,
		tracking = {},
		text = {},
		removedcurrency = {}
	}
}

local options = {
	name = "Broker Itemlist",
	handler = mod,
	type = "group",
	args = { 
		items = {
		 	type = "multiselect",
		 	name = L["Items"],
		 	desc = L["Items you wish to monitor in tooltip."],
		 	get = function(info, id) 
		 			return mod:ItemExists(id) 
		 		end,
		 	set = function(info, id) 
		 			mod:ToggleItem(id)
		 		end,
		 	values = "GetItems", 
		 	order = 5
		},
		textify = {
			type = "select",
		 	name = L["Show in text"],
		 	desc = L["Items you wish to show in text field."],
		 	get = function(info, id) 
		 			return mod:ItemOnText(id) 
		 		end,
		 	set = function(info, id) 
		 			mod:ToggleTextItem(id)
		 		end,
		 	values = "GetItems", 
			order = 8
		},
		head = {
			type = "header",
			name = L["Settings"],
			order = 10
		},
		additem = {
			type = "input",
			name = L["Add item"],
			desc = L["Add new item to track.  Drag the item to this input box."],
			set = 	function(info, v) mod:AddNewItem(v) end,
			order = 12
		},
		delitem = {
			type = "select",
			name = L["Delete item"],
			desc = L["List of current items.  Click to delete item."],
			set = function(info, id) mod:RemoveItem(id) end,
			values = "GetItems",
			order = 15
		},
		iconsize = {
			type = "range",
			name = L["Icon size"],
			get = function() return mod.db.char.iconsize end,
			set = 	function(info, v) mod.db.char.iconsize = v mod:UpdateBrokerText() end,
			min = 8, 
			max = 40, 
			step = 1,
			order = 20
		},
		iconx = {
			type = "range",
			name = L["Icon x offset"],
			desc = L["Horizontal distance between icon and text."],
			get = function() return mod.db.char.iconx end,
			set = 	function(info, v) mod.db.char.iconx = v mod:UpdateBrokerText() end,
			min = -5, 
			max = 5, 
			step = 1,
			order = 25
		},
		icony = {
			type = "range",
			name = L["Icon y offset"],
			desc = L["Vertical attachment of text to icon."],
			get = function() return mod.db.char.icony end,
			set = 	function(info, v) mod.db.char.icony = v mod:UpdateBrokerText() end,
			min = -10, 
			max = 20, 
			step = 1,
			order = 30
		},
		dev = {
			type = "toggle",
			name = L["Dev Mode"],
			get = function() return mod.db.char.devmode end,
			set = function(info, v) mod.db.char.devmode = v end,
			order = 50
		},
	}
}
		

function mod:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BrokerItemlistDB", defaults)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_Itemlist", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_Itemlist", "Broker Itemlist")
	
	_, playerClass = UnitClass("player")
	if mod.db.char.firstrun then
		for _, item in pairs(ReagentDefaults[playerClass]) do
			mod.db.char.tracking[item] = true
			mod.db.char.text[item] = true
		end
		mod.db.char.firstrun = false
	end
	self:CreateLDBObject()
end

function mod:OnEnable()
	db = mod.db.char
	
	self:InitialiseItemInfo()
	self:UpdateBrokerText()
	self:RegisterBucketEvent("BAG_UPDATE", 10)	
end

function mod:OnDisable()
	
end

function mod:debug(message)
	if db.devmode then
		DEFAULT_CHAT_FRAME:AddMessage("ITEMLIST: " .. (message or "NIL"))
	end
end

function mod:UpdateCurrencies()
	local numEntries = GetCurrencyListSize()
	self:debug(numEntries)
	for i = 1, numEntries do
		local name, isHeader, _, _, _, count, _, icon, itemID = GetCurrencyListInfo(i)
		if not isHeader then
			local _, _, itemRarity, _, _, itemType, _, itemStackCount, _, _ = GetItemInfo(itemID)
			self:debug(name)
			if not db.tracking[itemID] and db.tracking[itemID] ~= false and not db.removedcurrency[itemID] then
				db.tracking[itemID] = true
				db.text[itemID] = false
			end
			ItemInfo[itemID] = {name = name, icon = icon, count = count, max = itemStackCount, color = QualityColor[itemRarity + 1], quality = itemRarity, type = itemType}
		end
	end
	CURRENCYUPDATED = true
end

function mod:InitialiseItemInfo()
	for item in pairs(db.tracking) do
		self:AddItem(item) 
	end
end

function mod:ItemExists(id)
	if db.tracking[id] then return true
	else return false end
end

function mod:ToggleItem(id)
	db.tracking[id] = not db.tracking[id]
	self:UpdateBrokerText()
end

function mod:ItemOnText(id)
	if db.text[id] then return true 
	else return false end
end

function mod:ToggleTextItem(id)
	db.text[id] = not db.text[id]
	self:UpdateBrokerText()
end

function mod:GetItems()
	itemsList = {}
	for item in pairs(db.tracking) do
		if ItemInfo[item] then
			itemsList[item] = ItemInfo[item].color .. ItemInfo[item].name .. "|r"
		end
	end
	return itemsList
end

function mod:AddNewItem(itemlink)
	if not itemlink then return end
	local _,_, item = string.find(itemlink, "item:(%d+):")
	item = tonumber(item)
	if item and not db.tracking[item] then
		db.tracking[item] = true
		db.text[item] = false
		mod:AddItem(item)
		mod:BAG_UPDATE()
	end 
end

function mod:RemoveItem(id)
	db.tracking[id] = nil
	db.text[id] = nil 
	db.removedcurrency[id] = true
	self:UpdateBrokerText()
end

function mod:CreateLDBObject()
	mod.obj = ldb:NewDataObject("Broker_Itemlist", {
		type = "data source",
		icon = ClassIcons[playerClass],
		label = "Itemlist",
		OnClick = function(frame, button)
				if button == "RightButton" then
					if not C.OpenFrames["Broker_Itemlist"] then 
						mod:UpdateCurrencies() 
						C:Open("Broker_Itemlist") 
					else C:Close("Broker_Itemlist") end
				end
			end,
		OnEnter = function(frame)
				local tooltip = QTC:Acquire("Broker_ItemlistTooltip", 3, "LEFT", "LEFT", "RIGHT")
				tooltip:Clear()
				tooltip:SmartAnchorTo(frame)
				tooltip:SetScript("OnLeave", mod.HideTooltip)
				mod.tooltip = tooltip
				mod:DisplayTooltip()
			end,
		OnLeave = function()
				mod:HideTooltip()
			end,
	})

end

function mod:HideTooltip()
	if self.tooltip then
		self.tooltip:Hide()
		QTC:Release(self.tooltip)
		self.tooltip = nil
	end
end

function mod:UpdateBrokerText()
	local icons
	local text = ""
	for itemid, show in pairs(db.text) do
		if show and ItemInfo[itemid] then
			local data = ItemInfo[itemid]
			text = text .. "|T" .. data.icon .. ":" .. db.iconsize .. ":" .. db.iconsize .. ":" .. db.iconx .. ":" .. db.icony .. "|t"
			local color
			if data.count < data.max then color = "|c00FFFF00"
			else color = "|c0000FF00" end 
			text = text .. color .. data.count .. "|r"
			icons = true
		end
	end
	if icons then
		mod.obj.text = text
	else 
		mod.obj.text = ""
	end
end

function mod:DisplayTooltip()
	sorted = {}
	for itemid, show in pairs(db.tracking) do
		if show and ItemInfo[itemid] then
			local data = ItemInfo[itemid]
			table.insert(sorted, {name = data.name, icon = data.icon, count = data.count, max = data.max, color = data.color, quality = data.quality})
		end
	end
	if not sorted or #sorted == 0 then return end
	table.sort(sorted, function(a,b) 
				if a.quality == b.quality then
					return a.name < b.name 
				else
					return a.quality > b.quality
				end
	end)
	for _, data in ipairs(sorted) do
		local icontext = "|T" .. data.icon .. ":" .. db.iconsize .. "|t"
		local nametext = data.color .. data.name .. "|r"
		local color
		if data.count < data.max then color = "|c00FFFF00"
		else color = "|c0000FF00" end 
		local counttext = color .. data.count .. "|r"
		mod.tooltip:AddLine(icontext, nametext, counttext)
	end
			
	mod.tooltip:Show()
end

function mod:BAG_UPDATE()
	self:debug("Bag_UPDATE")
	if not CURRENCYUPDATED then self:UpdateCurrencies() end
	for item, data in pairs(ItemInfo) do
		data.count = 0 
	end
	for bag = 4, 0, -1 do
		local size = GetContainerNumSlots(bag)
		if (size > 0) then
			for slot = 1, size, 1 do
				local _, itemCount = GetContainerItemInfo(bag, slot)
				if itemCount then
					local itemName, itemLink, _, _, _, _, _, _, _, itemTexture = GetItemInfo(GetContainerItemLink(bag, slot))
					if itemLink then
						local _,_, itemId = string.find(itemLink, "item:(%d+):")
						itemId = tonumber(itemId)
						if db.tracking[itemId] and ItemInfo[itemId] then 
							ItemInfo[itemId].count = ItemInfo[itemId].count + itemCount 
						else
							for trackitem in pairs(db.tracking) do
								if ItemInfo[trackitem] then
									if string.find(itemName, ItemInfo[trackitem].name) then
										ItemInfo[trackitem].count = ItemInfo[trackitem].count + itemCount
										break
									end
								end
							end
						end
					end
				end
			end
		end
	end
	self:CurrencyBagUpdate()
	self:UpdateBrokerText()
end

function mod:AddItem(item)
	if not ItemInfo[item] then
		self:debug("Getting item info")
		local itemName, _, itemRarity, _, _, itemType, _, itemStackCount, _, itemTexture = GetItemInfo(item)
		if not itemName then 
			self:ScanTooltip(item)
			return
		end
		ItemInfo[item] = {name = itemName, icon = itemTexture, count = 0, max = itemStackCount, color = QualityColor[itemRarity + 1], quality = itemRarity, type = itemType}
	end
end

function mod:CurrencyBagUpdate()
	for i=1,GetCurrencyListSize() do
      		local _, _, _, _, _, count, _, _, itemID = GetCurrencyListInfo(i)
		if ItemInfo[itemID] then ItemInfo[itemID].count = count end
    	end
end

function mod:ScanTooltip(item)
	self:debug("Start scanning .."..item)
	if not self.Scanner then 
		self.Scanner = CreateFrame("GameTooltip", "Itemlist_ScannerTooltip", nil, "GameTooltipTemplate")
		self.Scanner:SetOwner(UIParent, "ANCHOR_NONE")
	end
	self.Scanner:SetHyperlink('item:'..item)
	self.Scanner.id = item
	self.Scanner:SetScript('OnTooltipSetItem', function() return mod:OnTooltipSetItem() end)
end

function mod:OnTooltipSetItem()
	mod:debug("Returned itemlookup")
	if GetItemInfo(mod.Scanner.id) then
		mod.Scanner:SetScript('OnTooltipSetItem', nil)
		mod:AddItem(mod.Scanner.id)
	end
end